/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

/**
 * Created by ${PRODUCT_NAME}.
 * User: porcherg
 * Date: 16/02/11
 * Time: 11:10
 * To change this template use File | Settings | File Templates.
 */
package org.ow2.orchestra.designer.business {
import com.adobe.cairngorm.business.ServiceLocator;

import flash.events.Event;

import mx.core.Application;
import mx.events.FlexEvent;
import mx.messaging.ChannelSet;
import mx.messaging.channels.AMFChannel;
import mx.rpc.remoting.mxml.RemoteObject;

public class Services extends ServiceLocator {

  [Bindable]
  public var processNavigator:RemoteObject;

  [Bindable]
  public var wsdlNavigator:RemoteObject;

  [Bindable]
  public var deployer:RemoteObject;

  [Bindable]
  public var sessionManager:RemoteObject;

  public function Services() {
    super();
    Application.application.addEventListener(FlexEvent.INITIALIZE, initialize);
  }

  private function initialize(event:Event = null):void {
    // Init client-server communications channels properties
    var context:String = parseURL(Application.application.systemManager.loaderInfo.url);

    var amfChannelSet:ChannelSet = new ChannelSet();
    var amfChannel:AMFChannel = new AMFChannel("my-graniteamf", context + "/graniteamf/amf");

    amfChannelSet.addChannel(amfChannel);

    // Init processNavigator remote object
    processNavigator = new RemoteObject();
    processNavigator.destination = "processNavigator";
    processNavigator.operations = {};
    processNavigator.initialized(this, "processNavigator");
    processNavigator.channelSet = amfChannelSet;

    // Init wsdlNavigator remote object
    wsdlNavigator = new RemoteObject();
    wsdlNavigator.destination = "wsdlNavigator";
    wsdlNavigator.operations = {};
    wsdlNavigator.initialized(this, "wsdlNavigator");
    wsdlNavigator.channelSet = amfChannelSet;

    // Init orchestra engine deployer remote object
    deployer = new RemoteObject();
    deployer.destination = "deployer";
    deployer.operations = {};
    deployer.initialized(this, "deployer");
    deployer.channelSet = amfChannelSet;

    // Init sessionManager remote object
    sessionManager = new RemoteObject();
    sessionManager.destination = "sessionsmanager";
    sessionManager.operations = {};
    sessionManager.initialized(this, "sessionManager");
    sessionManager.channelSet = amfChannelSet;

  }

  /**
   * Parse the input URL and return the associated context.
   */
  public static function parseURL(s:String):String {
    var lastSlashIndex:int = s.lastIndexOf("/");
    if (lastSlashIndex != -1) {
      return s.substring(0, lastSlashIndex);
    }
    return s;
  }
}
}
