/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

/**
 * Created by IntelliJ IDEA.
 * User: cisse
 * Date: 31/05/11
 * Time: 09:45
 * To change this template use File | Settings | File Templates.
 */
package org.ow2.orchestra.designer.commands {
import com.adobe.cairngorm.business.ServiceLocator;
import com.adobe.cairngorm.commands.ICommand;
import com.adobe.cairngorm.control.CairngormEvent;

import mx.collections.ArrayCollection;
import mx.rpc.AsyncToken;
import mx.rpc.Responder;
import mx.rpc.events.FaultEvent;
import mx.rpc.events.ResultEvent;
import mx.rpc.remoting.RemoteObject;

import org.ow2.orchestra.designer.events.AccessPropertiesEvent;
import org.ow2.orchestra.designer.events.CollectionAddAllEvent;
import org.ow2.orchestra.designer.model.DesignerModelLocator;
import org.ow2.orchestra.designer.utils.ErrorManager;
import org.ow2.orchestra.designer.vo.FileNavigatorProcess;

public class ChangeAccessSettingsProcessCMD implements ICommand {

  public function ChangeAccessSettingsProcessCMD() {
  }

  public function execute(event:CairngormEvent):void {
    var process:FileNavigatorProcess = (event as AccessPropertiesEvent).process;
    DesignerModelLocator.getInstance().accessProcessSettings.selectedProcess = process;
    DesignerModelLocator.getInstance().accessProcessSettings.lAccess.removeAll();
    if (process != null) {
      var remote:RemoteObject = ServiceLocator.getInstance().getRemoteObject("processNavigator");
      var token:AsyncToken = remote.getAccessProperties(process);
      // add functions to call on result
      token.addResponder(new Responder(getAccessPropertiesResult, fault));
    }
  }

  private function getAccessPropertiesResult(event:ResultEvent):void {
    DesignerModelLocator.getInstance().accessProcessSettings.lAccess.addAll(event.result as ArrayCollection);
    DesignerModelLocator.getInstance().accessProcessSettings.lAccess.dispatchEvent(
            new CollectionAddAllEvent(CollectionAddAllEvent.COLLECTION_CHANGE_ADD_ALL, ArrayCollection(event.result).toArray()));
  }

  private function fault(event:FaultEvent):void {
    ErrorManager.getInstance().showError("Remote invoke error: " + event.message);
  }
}
}
