/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.commands {
import com.adobe.cairngorm.business.ServiceLocator;
import com.adobe.cairngorm.commands.ICommand;
import com.adobe.cairngorm.control.CairngormEvent;

import mx.rpc.AsyncToken;
import mx.rpc.Responder;
import mx.rpc.events.FaultEvent;
import mx.rpc.events.ResultEvent;
import mx.rpc.remoting.RemoteObject;

import org.ow2.orchestra.designer.business.GravityService;
import org.ow2.orchestra.designer.model.DesignerModelLocator;
import org.ow2.orchestra.designer.utils.ErrorManager;

public class GetUsernameCMD implements ICommand {
  public function GetUsernameCMD() {
  }

  public function execute(event:CairngormEvent):void {
    var remote:RemoteObject = ServiceLocator.getInstance().getRemoteObject("sessionManager");
    var token:AsyncToken = remote.getUsername();
    // add functions to call on result
    token.addResponder(new Responder(getUsernameResult, fault));
  }

  private function getUsernameResult(event:ResultEvent):void {
    var userName:String;
    //getting username
    userName = event.result as String;
    DesignerModelLocator.getInstance().userName = userName;
    GravityService.getInstance().register();
  }

  private function fault(event:FaultEvent):void {
    ErrorManager.getInstance().showError("Remote invoke error: " + event.message);
  }

}
}