/**
 * @author Loic Albertin
 */
package org.ow2.orchestra.designer.commands {
import com.adobe.cairngorm.commands.Command;
import com.adobe.cairngorm.control.CairngormEvent;

import org.ow2.orchestra.designer.events.NotificationEvent;
import org.ow2.orchestra.designer.model.DesignerModelLocator;
import org.ow2.orchestra.designer.model.NotificationMessage;

public class NotificationCMD implements Command {
  public function NotificationCMD() {
  }

  public function execute(event:CairngormEvent):void {
    if (event is NotificationEvent) {
      var message:NotificationMessage = NotificationEvent(event).message;
      switch (event.type) {
        case NotificationEvent.ADD_NOTIFICATION:
        {
          if (message != null) {
            DesignerModelLocator.getInstance().unreadNotifications.addItemAt(message, 0);
          }
          break;
        }
        case NotificationEvent.REMOVE_NOTIFICATION:
        {
          if (message != null) {
            var msgInd:int = DesignerModelLocator.getInstance().unreadNotifications.getItemIndex(message);
            if (msgInd != -1) {
              DesignerModelLocator.getInstance().unreadNotifications.removeItemAt(msgInd);
            }
          }
          break;
        }
        case NotificationEvent.CLEAR_NOTIFICATIONS:
        {
          DesignerModelLocator.getInstance().unreadNotifications.removeAll();
          break;
        }
      }
    }
  }
}
}
