/**
 * Created by IntelliJ IDEA.
 * User: camillej
 * Date: 13/12/11
 * Time: 10:29
 * To change this template use File | Settings | File Templates.
 */
package org.ow2.orchestra.designer.commands.dataTypes {
import com.adobe.cairngorm.commands.ICommand;
import com.adobe.cairngorm.control.CairngormEvent;

import org.ow2.orchestra.designer.FlexQName;

import org.ow2.orchestra.designer.bpmn.model.AbstractElement;
import org.ow2.orchestra.designer.bpmn.model.data.type.XSDSequenceType;
import org.ow2.orchestra.designer.bpmn.model.data.type.XSDSimpleType;
import org.ow2.orchestra.designer.bpmn.model.data.type.WSDLMessageModel;
import org.ow2.orchestra.designer.bpmn.model.data.type.WSDLMessagePartModel;
import org.ow2.orchestra.designer.bpmn.model.data.type.XSDElementModel;
import org.ow2.orchestra.designer.bpmn.model.data.type.XSDTypeModel;
import org.ow2.orchestra.designer.bpmn.model.data.type.XSDTypeModel;
import org.ow2.orchestra.designer.bpmn.model.process.EventModel;
import org.ow2.orchestra.designer.bpmn.model.process.EventType;
import org.ow2.orchestra.designer.bpmn.model.process.ProcessModel;
import org.ow2.orchestra.designer.bpmn.model.utils.IDUtil;

import org.ow2.orchestra.designer.events.DataTypesChangeEvent;
import org.ow2.orchestra.designer.model.DesignerModelLocator;
import org.ow2.orchestra.designer.model.ProcessEditorModel;

public class AddDataTypesCMD implements ICommand {
  public function AddDataTypesCMD() {
  }

  public function execute(event:CairngormEvent):void {
    var dataTypeEvent:DataTypesChangeEvent = event as DataTypesChangeEvent;
    var processEditorModel:ProcessEditorModel = dataTypeEvent.processEditorModel;
    if (processEditorModel.selectedElements.length == 1) {
      var selectedElementModel:AbstractElement = processEditorModel.selectedElements.getItemAt(0) as AbstractElement;
      if (dataTypeEvent.type == DataTypesChangeEvent.DATA_TYPE_ADD) {
        if (selectedElementModel is EventModel) {
          var selectedEvent:EventModel = selectedElementModel as EventModel;
          var selectedDataType:WSDLMessageModel;
          if (selectedEvent.eventType == EventType.RECEIVE_MESSAGE
              && (selectedEvent.operation != null && selectedEvent.operation.inMessageType != null)) {
            selectedDataType = selectedEvent.operation.inMessageType as WSDLMessageModel;
          }
          else if (selectedEvent.eventType == EventType.SEND_MESSAGE
              && (selectedEvent.operation != null && selectedEvent.operation.outMessageType != null)) {
            selectedDataType = selectedEvent.operation.outMessageType as WSDLMessageModel;
          }

          if (selectedDataType != null && selectedDataType.parts != null) {
            var xsdElt:XSDElementModel = new XSDElementModel();
            xsdElt.id = IDUtil.generateId();
            xsdElt.QName = FlexQName.valueOf("{" + processEditorModel.processModel.wsdlNamespace +
                "}" + dataTypeEvent.elementName);
            var xsdType:XSDSimpleType = new XSDSimpleType();
            xsdType.id = IDUtil.generateId();
            xsdType.QName = dataTypeEvent.typeQName;
            xsdElt.type = xsdType;
            var partModel:WSDLMessagePartModel = selectedDataType.parts.getItemAt(0) as WSDLMessagePartModel;

            if (partModel != null) {
              if (partModel.xsdElement != null && partModel.xsdElement.type is XSDSimpleType) {
                var seq:XSDSequenceType = new XSDSequenceType();
                seq.id = IDUtil.generateId();
                seq.QName = FlexQName.valueOf("{" + processEditorModel.processModel.wsdlNamespace + "}" + seq.id);
                seq.elements.addItem(partModel.xsdElement);
                seq.elements.addItem(xsdElt);
                partModel.xsdElement = null;
                partModel.xsdType = seq;
              } else if (partModel.xsdType != null && partModel.xsdType is XSDSequenceType) {
                XSDSequenceType(partModel.xsdType).elements.addItem(xsdElt);
              } else if (partModel.xsdElement != null && partModel.xsdElement.type is XSDSequenceType) {
                XSDSequenceType(partModel.xsdElement.type).elements.addItem(xsdElt);
              }
            }
          }
        }
      }
    }
  }
}
}
