/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2012 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

package org.ow2.orchestra.designer.commands.dataTypes {
import com.adobe.cairngorm.commands.ICommand;
import com.adobe.cairngorm.control.CairngormEvent;

import org.ow2.orchestra.designer.events.DataTypesChangeEvent;

/**
 * @author Loic Albertin
 */
public class UpdateDataTypesCMD implements ICommand {
  public function UpdateDataTypesCMD() {
  }

  public function execute(event:CairngormEvent):void {
    var dataTypeEvent:DataTypesChangeEvent = event as DataTypesChangeEvent;
    if (dataTypeEvent.type == DataTypesChangeEvent.DATA_TYPE_UPDATE &&
        dataTypeEvent.dataTypeModel != null && dataTypeEvent.typeQName != null) {
      dataTypeEvent.dataTypeModel.QName = dataTypeEvent.typeQName;
    }
  }
}
}
