/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.commands.editor {
import com.adobe.cairngorm.commands.ICommand;
import com.adobe.cairngorm.control.CairngormEvent;

import mx.collections.ListCollectionView;

import org.ow2.orchestra.designer.bpmn.model.FlowModel;

import org.ow2.orchestra.designer.events.FlowOrderingEvent;

public class ReorderFlowCMD implements ICommand {
  public function ReorderFlowCMD() {
  }

  /**
   * Executes the command.
   *  @param event a FlowEvent
   */
  public function execute(event:CairngormEvent):void {
    var flowEvt:FlowOrderingEvent = event as FlowOrderingEvent;
    trace("ReorderFlowCMD");

    // save process model
    flowEvt.diagramEditorModel.saveModelForUndo();
    // Change flow position
    var flowList:ListCollectionView = flowEvt.flowModel.targetElement.incomingFlows;
    if (flowList.length > 1) {
      var oldValue:FlowModel = flowList.setItemAt(flowList.getItemAt(0), 1) as FlowModel;
      flowEvt.flowModel.targetElement.incomingFlows.setItemAt(oldValue, 0);
    }
  }

}
}
