/**
 * Created by IntelliJ IDEA.
 * User: camillej
 * Date: 13/12/11
 * Time: 11:21
 * To change this template use File | Settings | File Templates.
 */
package org.ow2.orchestra.designer.events {
import org.ow2.orchestra.designer.FlexQName;
import org.ow2.orchestra.designer.bpmn.model.data.type.DataTypeModel;
import org.ow2.orchestra.designer.model.ProcessEditorModel;

public class DataTypesChangeEvent extends ProcessEvent {

  /**
   * Add a datatype file.
   */
  public static const DATA_TYPE_ADD:String = "DataTypesEvent_AddDataType";

  /**
   * Delete a datatype.
   */
  public static const DATA_TYPE_DELETE:String = "DataTypesEvent_DeleteDataType";

  /**
   * Update a datatype: Replace dataType's QName by the given type QName
   */
  public static const DATA_TYPE_UPDATE:String = "DataTypesEvent_UpdateDataType";

  private var _elementName:String;
  private var _typeQName:FlexQName;
  private var _dataTypeModel:DataTypeModel;

  public function DataTypesChangeEvent(type:String, processEditorModel:ProcessEditorModel,
                                       elementName:String = null, typeQName:FlexQName = null,
                                       dataTypeModel:DataTypeModel = null,
                                       bubbles:Boolean = false, cancelable:Boolean = false) {
    super(type, processEditorModel, bubbles, cancelable);
    _elementName = elementName;
    _typeQName = typeQName;
    _dataTypeModel = dataTypeModel;
  }

  /**
   * Only available for DATA_TYPE_ADD
   */
  public function get elementName():String {
    return _elementName;
  }

  /**
   * Only available for DATA_TYPE_ADD and DATA_TYPE_UPDATE
   */
  public function get typeQName():FlexQName {
    return _typeQName;
  }

  /**
   * Only available for DATA_TYPE_DELETE and DATA_TYPE_UPDATE
   */
  public function get dataTypeModel():DataTypeModel {
    return _dataTypeModel;
  }
}
}
