/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.events {
  import com.adobe.cairngorm.control.CairngormEvent;

  import org.ow2.orchestra.designer.bpmn.model.AbstractElement;
import org.ow2.orchestra.designer.model.DiagramEditorModel;

public class ElementPropertyChangeEvent extends DiagramEvent {
    /**
     * Change a process element property.
     */
    public static const PROPERTY_CHANGED:String = "ElementPropertyChangeEvent_PropertyChanged";

    private var _modelElement:AbstractElement;
    private var _propertyName:String;
    private var _propertyValue:Object;

    public function ElementPropertyChangeEvent(type:String, diagramEditorModel:DiagramEditorModel, modelElement:AbstractElement, propertyName:String, propertyValue:Object, bubbles:Boolean = false, cancelable:Boolean = false) {
      super(type, diagramEditorModel, bubbles, cancelable);
      _modelElement = modelElement;
      _propertyName = propertyName;
      _propertyValue = propertyValue;
    }

    public function get modelElement():AbstractElement {
      return _modelElement;
    }

    public function get propertyName():String {
      return _propertyName;
    }

    public function get propertyValue():Object {
      return _propertyValue;
    }
  }
}
