/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.events {
import org.ow2.orchestra.designer.bpmn.model.FlowModel;
import org.ow2.orchestra.designer.model.DiagramEditorModel;

public class FlowOrderingEvent extends DiagramEvent {
  /**
   * Change the index of the flow in the target element incoming flows list.
   */
  public static const REORDER:String = "FlowOrderingEvent";

  private var _flowModel:FlowModel;

  public function FlowOrderingEvent(
          flowElement:FlowModel,
          diagramEditorModel:DiagramEditorModel,
          bubbles:Boolean = false,
          cancelable:Boolean = false) {
    super(REORDER, diagramEditorModel, bubbles, cancelable);
    _flowModel = flowElement;
  }

  public function get flowModel():FlowModel {
    return _flowModel;
  }
}
}
