/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.events {
import com.adobe.cairngorm.control.CairngormEvent;

import org.ow2.orchestra.designer.model.NotificationMessage;

/**
 * @author Loic Albertin
 */
public class NotificationEvent extends CairngormEvent {

  /**
   * Add a given notification message to the unread notification list.
   */
  public static const ADD_NOTIFICATION:String = "NotificationEvent_Add";

  /**
   * Remove a given notification message to the unread notification list.
   */
  public static const REMOVE_NOTIFICATION:String = "NotificationEvent_Remove";

  /**
   * Clear the unread notification list.
   */
  public static const CLEAR_NOTIFICATIONS:String = "NotificationEvent_Clear";

  private var _message:NotificationMessage;

  public function NotificationEvent(type:String, notificationMessage:NotificationMessage = null, bubbles:Boolean = false, cancelable:Boolean = false) {
    super(type, bubbles, cancelable);
    _message = notificationMessage;
  }


  public function get message():NotificationMessage {
    return _message;
  }
}
}
