package org.ow2.orchestra.designer.utils {


  /**
   * Provide properties be used as the source for image data binding.
   */
  public class ContextPanelResources {
    private static var instance:ContextPanelResources;

    /**
     * The source for "balloon" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/balloon.png", scaleGridLeft="21",scaleGridTop="1",scaleGridRight="24",scaleGridBottom="79")]
    public var balloon:Class;

    /**
     * The source for "btn-remove" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/btn-remove.png")]
    public var btn_remove:Class;
    /**
     * The source for "btn-reorder" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/btn-reorder.svg")]
    public var btn_reorder:Class;
    /**
     * The source for "btn-label" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/btn-label.png")]
    public var btn_label:Class;
    /**
     * The source for "btn-link" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/link.svg")]
    public var btn_link:Class;
    /**
     * The source for "btn-add-gateway" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/gateway.svg")]
    public var btn_add_gateway:Class;
    /**
     * The source for "btn-add-event" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/event.svg")]
    public var btn_add_event:Class;
    /**
     * The source for "btn-add-task" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/task.svg")]
    public var btn_add_task:Class;
    /**
     * The source for "btn-link-disabled" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/link-disabled.svg")]
    public var btn_link_disabled:Class;
    /**
     * The source for "btn-add-gateway-disabled" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/gateway-disabled.svg")]
    public var btn_add_gateway_disabled:Class;
    /**
     * The source for "btn-add-event-disabled" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/event-disabled.svg")]
    public var btn_add_event_disabled:Class;
    /**
     * The source for "btn-add-task-disabled" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/task-disabled.svg")]
    public var btn_add_task_disabled:Class;

    /**
     * The source for "parallel gateway" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/parallelGateway.svg")]
    public var gateway_parallel_type:Class;

    /**
     * The source for "exclusive gateway" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/exclusiveGateway.svg")]
    public var gateway_exclusive_type:Class;

    /**
     * The source for "exclusive event gateway" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/eventBasedGateway.svg")]
    public var gateway_exclusive_event_type:Class;

    /**
     * The source for "sendMessageEvent" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/eventSendMessage.svg")]
    public var event_send_message_type:Class;

    /**
     * The source for "receiveMessageEvent" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/eventReceiveMessage.svg")]
    public var event_receive_message_type:Class;

    /**
     * The source for "timerEvent" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/eventTimer.svg")]
    public var event_timer_type:Class;

    /**
     * The source for "serviceTask" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/taskService.svg")]
    public var task_service_type:Class;

    /**
     * The source for "userTask" image data binding.
     */
    [Bindable]
    [Embed(source="/../assets/contextPanel/taskUser.svg")]
    public var task_user_type:Class;
    /**
     * The Resource constructor should only be created
     * through the static singleton getInstance() method.  Resource
     * provide properties be used as the source for image data binding.
     */
    public function ContextPanelResources() {
      if (instance != null) {
        throw new Error("Error: Singletons can only be instantiated via getInstance() method!");
      }
      ContextPanelResources.instance = this;
    }

    /**
     * Singleton access to the Resource is assured through the static getInstance()
     * method, which is used to retrieve the only ViewLocator instance in a Cairngorm
     * application.
     *
     * <p>Wherever there is a need to retreive the Resource instance, it is achieved
     * using the following code:</p>
     *
     * <pre>
     * var resource:Resource = Resource.getInstance();
     * </pre>
     */
    public static function getInstance():ContextPanelResources {
      if (instance == null) {
        instance = new ContextPanelResources();
      }
      return instance;
    }
  }
}
