/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.view.fileNavigator {
import mx.collections.ArrayCollection;
import mx.collections.ICollectionView;
import mx.collections.ListCollectionView;
import mx.collections.Sort;
import mx.collections.SortField;

/**
 * @author Loic Albertin
 */
public class ParentTreeItem extends TreeItem {

  private var _children:ArrayCollection = new ArrayCollection();

  public function ParentTreeItem(itemData:Object, children:ICollectionView = null) {
    super(itemData);

    var sort:Sort = new Sort();
    sort.fields = [new SortField("label")];
    _children.sort = sort;
    if (children != null) {
      for each (var object:Object in children) {
        _children.addItem(object);
      }
    }
  }

  public function get children():ListCollectionView {
    //refresh sort
    _children.refresh();
    return _children;
  }
}
}
