/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.view.palette {
import flash.display.DisplayObject;
import flash.events.MouseEvent;

import mx.containers.Box;
import mx.containers.BoxDirection;
import mx.core.DragSource;
import mx.managers.DragManager;

import org.ow2.orchestra.designer.model.ElementPaletteDnDModel;

public class AbstractPalette extends Box {

  public function AbstractPalette() {
    super();
    //Default is vertical box
    this.direction = BoxDirection.VERTICAL;
  }

  /** Drag event handler for palette elements */
  private function startDragElement(evt:MouseEvent):void {
    var paletteElement:AbstractElementPalette = evt.currentTarget as AbstractElementPalette;
    if (paletteElement.enabled) {
      // Create a new DragSource
      var dragSource:DragSource = new DragSource();

      //Create an element drag and drop model
      var elemDnDModel:ElementPaletteDnDModel =
          new ElementPaletteDnDModel(evt.localX, evt.localY, paletteElement.duplicateImage());
      dragSource.addData(elemDnDModel, "paletteItem");

      // Start Drag mode using image from the element drag'n'drop model
      DragManager.doDrag(paletteElement, dragSource, evt, elemDnDModel.image);
    }
  }

  /** Add a new element to the palette
   * Handle drag event for this element
   */
  protected function addElementToPalette(element:AbstractElementPalette):void {
    this.addChild(element as DisplayObject);
    element.addEventListener(MouseEvent.MOUSE_DOWN, startDragElement);
  }

}
}
