/**
 * @author Loic Albertin
 */
package org.ow2.orchestra.designer.view.palette.datamapping {
import mx.containers.BoxDirection;
import mx.controls.VRule;
import mx.core.ScrollPolicy;

import org.ow2.orchestra.designer.bpmn.model.data.ExpressionOperationModel;
import org.ow2.orchestra.designer.bpmn.views.data.ExpressionOperationView;

import org.ow2.orchestra.designer.view.palette.AbstractPalette;

public class DataMappingPalette extends AbstractPalette {
  public function DataMappingPalette() {
    super();

    this.direction = BoxDirection.HORIZONTAL;
    this.verticalScrollPolicy = ScrollPolicy.OFF;

    this.setStyle("borderStyle", "solid");
    this.setStyle("borderThickness", "2");
    this.percentWidth = 100;
    this.height = 40;

    var padding:String = "2";
    var inputDataPaletteView:DataObjectPaletteView = new DataObjectPaletteView(this);
    inputDataPaletteView.automationName = "dmPaletteInputDataView";
    inputDataPaletteView.horizontalScrollPolicy = ScrollPolicy.OFF;
    inputDataPaletteView.verticalScrollPolicy = ScrollPolicy.OFF;
    inputDataPaletteView.setStyle("paddingBottom", padding);
    inputDataPaletteView.setStyle("paddingLeft", padding);
    inputDataPaletteView.setStyle("paddingRight", padding);
    inputDataPaletteView.setStyle("paddingTop", padding);

    this.addElementToPalette(inputDataPaletteView);

    var vRule:VRule = new VRule();
    vRule.setStyle("strokeWidth", "5");
    vRule.width = 2;
    vRule.height = 40;
    this.addChild(vRule);

    var literalPaletteView:LiteralPaletteView = new LiteralPaletteView(this);
    literalPaletteView.automationName = "dmPaletteLiteralView";
    literalPaletteView.horizontalScrollPolicy = ScrollPolicy.OFF;
    literalPaletteView.verticalScrollPolicy = ScrollPolicy.OFF;
    literalPaletteView.setStyle("paddingBottom", padding);
    literalPaletteView.setStyle("paddingLeft", padding);
    literalPaletteView.setStyle("paddingRight", padding);
    literalPaletteView.setStyle("paddingTop", padding);
    this.addElementToPalette(literalPaletteView);

    var operationPaletteView:ExpressionOperationPaletteView = new ExpressionOperationPaletteView(this);
    operationPaletteView.automationName = "dmPaletteOperationView";
    operationPaletteView.horizontalScrollPolicy = ScrollPolicy.OFF;
    operationPaletteView.verticalScrollPolicy = ScrollPolicy.OFF;
    operationPaletteView.setStyle("paddingBottom", padding);
    operationPaletteView.setStyle("paddingLeft", padding);
    operationPaletteView.setStyle("paddingRight", padding);
    operationPaletteView.setStyle("paddingTop", padding);
    this.addElementToPalette(operationPaletteView);

    var vRule2:VRule = new VRule();
    vRule2.setStyle("strokeWidth", "5");
    vRule2.width = 2;
    vRule2.height = 40;
    this.addChild(vRule2);

    var outputDataPaletteView:DataInputPaletteView = new DataInputPaletteView(this);
    outputDataPaletteView.automationName = "dmPaletteOutputDataView";
     outputDataPaletteView.horizontalScrollPolicy = ScrollPolicy.OFF;
     outputDataPaletteView.verticalScrollPolicy = ScrollPolicy.OFF;
    outputDataPaletteView.setStyle("paddingBottom", padding);
    outputDataPaletteView.setStyle("paddingLeft", padding);
    outputDataPaletteView.setStyle("paddingRight", padding);
    outputDataPaletteView.setStyle("paddingTop", padding);
    this.addElementToPalette(outputDataPaletteView);

  }
}
}
