/**
 * @author Loic Albertin
 */
package org.ow2.orchestra.designer.view.palette.datamapping {
  import mx.events.CollectionEvent;
  import mx.events.PropertyChangeEvent;

  import org.ow2.orchestra.designer.model.DesignerModelLocator;
  import org.ow2.orchestra.designer.model.ProcessEditorModel;
  import org.ow2.orchestra.designer.view.palette.AbstractElementPalette;

  public class DataObjectPaletteView extends AbstractElementPalette {

    /**
     * The source for "OutputData" image data binding into the palette.
     */
    [Bindable]
    [Embed(source="/../assets/palette/dataObjectDefault.svg")]
    public var defaultImgDataObject:Class;

    public function DataObjectPaletteView(parentPalette:DataMappingPalette) {
      super(defaultImgDataObject, "", parentPalette, 20, 30);
//We want to enable or disable this abstract element palette, so lets inspect the currently selected process editor model
      DesignerModelLocator.getInstance().addEventListener(PropertyChangeEvent.PROPERTY_CHANGE, propertyChangeHandler);
    }

    private function propertyChangeHandler(event:PropertyChangeEvent):void {
      if (event.property == "selectedProcessEditor") {
        //if there was a selected process editor remove listeners
        if (event.oldValue != null) {
          ProcessEditorModel(event.oldValue).processModel.dataObjects.removeEventListener(CollectionEvent.COLLECTION_CHANGE, collectionChangeHandler);
        }
        //if there is a selected process editor add listeners
        if (event.newValue != null) {
          ProcessEditorModel(event.newValue).processModel.dataObjects.addEventListener(CollectionEvent.COLLECTION_CHANGE, collectionChangeHandler);
          collectionChangeHandler();
        }
      }
    }

    private function collectionChangeHandler(event:CollectionEvent = null):void {
      this.enabled = DesignerModelLocator.getInstance().selectedProcessEditor.processModel.dataObjects.length > 0;
    }
  }
}
