/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.vo {
import com.adobe.cairngorm.vo.IValueObject;

/**
 *
 * @author diouf-a
 */
[Bindable]
[RemoteClass(alias="org.ow2.orchestra.designer.processNavigator.UserAccessPermissions")]
public class FileNavigatorUserAccessPermissions implements IValueObject {
  private var _user:String;
  private var _writing:Boolean;
  private var _reading:Boolean;
  private var _admin:Boolean;
  private var _deleting:Boolean;


  public function FileNavigatorUserAccessPermissions() {
    this._user = "";
    this._writing = false;
    this._reading = false;
    this._admin = false;
    this._deleting = false;
  }

  public function get user():String {
    return this._user;
  }

  public function get reading():Boolean {
    return this._reading;
  }

  public function get writing():Boolean {
    return this._writing;
  }

  public function get admin():Boolean {
    return this._admin;
  }

  public function get deleting():Boolean {
    return this._deleting;
  }

  public function set user(user:String):void {
    this._user = user;
  }

  public function set reading(reading:Boolean):void {
    this._reading = reading;
  }

  public function set writing(writing:Boolean):void {
    this._writing = writing;
  }

  public function set admin(admin:Boolean):void {
    this._admin = admin;
  }

  public function set deleting(deleting:Boolean):void {
    this._deleting = deleting;
  }
}
}
